DemuxOutputStream (Commons IO 2.5)
Date: 2016-12-01

org.apache.commons.io.output

## Class DemuxOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.commons.io.output.DemuxOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

      public class DemuxOutputStream
      extends java.io.OutputStream

  Forwards data to a stream that has been associated with this thread.
  Version:
    $Id: DemuxOutputStream.java 1737901 2016-04-06 00:23:36Z ggregory $

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private java.lang.InheritableThreadLocal<java.io.OutputStream>` | `outputStreamThreadLocal`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DemuxOutputStream()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.io.OutputStream` | `bindStream(java.io.OutputStream output)` Binds the specified stream to the current thread.
    `void` | `close()` Closes stream associated with current thread.
    `void` | `flush()` Flushes stream associated with current thread.
    `void` | `write(int ch)` Writes byte to stream associated with current thread.

    - ### Methods inherited from class java.io.OutputStream

      `write, write`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### outputStreamThreadLocal

          private final java.lang.InheritableThreadLocal<java.io.OutputStream> outputStreamThreadLocal

  - ### Constructor Detail

    - #### DemuxOutputStream

          public DemuxOutputStream()

  - ### Method Detail

    - #### bindStream

          public java.io.OutputStream bindStream(java.io.OutputStream output)

      Binds the specified stream to the current thread.
      Parameters:
        `output` - the stream to bind
      Returns:
        the OutputStream that was previously active

    - #### close

          public void close()
                     throws java.io.IOException

      Closes stream associated with current thread.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException` - if an error occurs

    - #### flush

          public void flush()
                     throws java.io.IOException

      Flushes stream associated with current thread.
      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException` - if an error occurs

    - #### write

          public void write(int ch)
                     throws java.io.IOException

      Writes byte to stream associated with current thread.
      Specified by:
        `write` in class `java.io.OutputStream`
      Parameters:
        `ch` - the byte to write to stream
      Throws:
        `java.io.IOException` - if an error occurs

Copyright (c) 2002-2016 Apache Software Foundation